<template>
  <v-app id="app" ref="container">
    <v-navigation-drawer
      id="drawer"
      :expand-on-hover="true"
      permanent
      app
      clipped
    >
      <v-list nav class="py-0">
        <v-list-item
          v-for="item in items"
          :key="item.title"
          link
          @click="item.func"
        >
          <v-list-item-icon>
            <v-icon>{{ item.icon }}</v-icon>
          </v-list-item-icon>
          <v-list-item-content>
            <v-list-item-title>{{ item.title }}</v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <v-divider></v-divider>

        <v-list-item>
          <v-list-item-avatar></v-list-item-avatar>
          <v-list-item-content>
            <v-list-item-title> </v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </v-navigation-drawer>

    <v-app-bar app clipped-left class="elevation-1">
      <v-toolbar-title>Forecast</v-toolbar-title>
      <v-spacer></v-spacer>
      <v-img
        :src="require('@/assets/altair_logo.png')"
        height="64px"
        width="128px"
        contain
        class="ml-15"
      />
      <v-spacer></v-spacer>
      <v-switch
        v-model="dark"
        class="mt-5"
        color="white"
        :prepend-icon="dark ? 'mdi-weather-night' : 'mdi-white-balance-sunny'"
        inset
      ></v-switch>
    </v-app-bar>

    <v-main>
      <v-container fluid>
        <v-row style="height: 100%">
          <v-col cols="12" lg="6" order="1">
            <Logs style="height: 470px; max-height: 470px" />
          </v-col>
          <v-col cols="12" lg="6" order="2">
            <Status style="height: 470px; max-height: 470px" />
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" lg="12">
            <v-card style="height: 100%">
              <v-card-title></v-card-title>
              <v-card-text>
                <Chart />
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-main>

    <Settings />
    <About :version="version" />
    <FirstBoot :first_boot="first_boot" :updates="updates" @closed="first_boot = false" />

    <vue-snotify></vue-snotify>
  </v-app>
</template>

<script>
import Status from "./components/BoardOverview/Status";
import Logs from "./components/Logs";
import Chart from "./components/Chart";

import Settings from "./components/Settings";
import About from "./components/About";
import FirstBoot from "./components/FirstBoot";

export default {
  name: "App",
  components: {
    Status,
    Logs,
    Chart,
    Settings,
    About,
    FirstBoot,
  },
  data() {
    return {
      items: [
        { title: "Dashboard", icon: "mdi-view-dashboard", func: () => {} },
        { title: "Settings", icon: "mdi-cogs", func: this.showSettings },
        { title: "About", icon: "mdi-account", func: this.showAbout },
      ],
      first_boot: false,
      version: "0.0.0",
      updates: {}
    };
  },
  methods: {
    showAbout() {
      this.$store.dispatch("drawer/showAbout", true);
    },
    showSettings() {
      this.$store.dispatch("drawer/showSettings", true);
    },
  },
  computed: {
    dark: {
      get() {
        return this.$vuetify.theme.dark;
      },
      set(value) {
        this.$vuetify.theme.dark = value;
        this.$axios
          .post("/settings", {
            option: "dark",
            value: String(value),
          })
          .then(() => {})
          .catch(() => {
            this.$notify.error("Error while saving settings");
          });
      },
    },
  },
  mounted() {
    this.$axios
      .get("/settings")
      .then((res) => {
        this.$vuetify.theme.dark = String(res.data.General.dark) == "true";
        this.$store.dispatch("settings/setMode", Number(res.data.General.mode));
      })
      .catch((err) => {
        console.log(err);
      });

    this.$socket.on("boot_settings", (data) => {
      this.version = data.version;
      this.updates = data.updates;
      this.first_boot = data.first_boot;
    });
  },
};
</script>

<style>
html {
  font-family: Roboto;
  overflow-y: auto;
}
#app {
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  background-color: var(--v-background-base) !important;
}
#drawer {
  text-align: center;
}
</style>
